

__shared__ float sMem1[512];
__shared__ float sMem2[512];

#define NUMTHREADS		16
#define NUMELEMENTS		16*4
#define NUMLOOP			1

__device__ void setValue1(unsigned int* gRet, unsigned int* gOpA, unsigned int* gOpB)
{
	unsigned int cnt_i;
	//unsigned int index = threadIdx.x*blockDim.y+threadIdx.y;
	unsigned int index = threadIdx.y;
	unsigned int* ptrOpA, *ptrOpB, *ptrRet;
	unsigned int temp;
	index <<= 6;
	ptrOpA = gOpA+index;
	ptrOpB = gOpB+index;
	ptrRet = gRet+index;

	for(cnt_i = 0; cnt_i < NUMELEMENTS; cnt_i++)
	{
		ptrRet[cnt_i] = ptrOpA[cnt_i]*ptrOpB[cnt_i];
	}
}

__device__ void setValue2(unsigned int* gRet, unsigned int* gOpA, unsigned int* gOpB)
{
	unsigned int cnt_i, cnt_j;
	unsigned int index = threadIdx.y;
	unsigned int* ptrOpA, *ptrOpB, *ptrRet;
	ptrOpA = gOpA+index;
	ptrOpB = gOpB+index;
	ptrRet = gRet+index;

	for(cnt_i = 0; cnt_i < NUMELEMENTS; cnt_i++)
	{
		cnt_j = cnt_i << 4;
		ptrRet[cnt_j] = ptrOpA[cnt_j]*ptrOpB[cnt_j];
	}
}

__device__ void getValue1()
{

}

__device__ void getValue2()
{

}

__global__ void 
UnCoalscedMemTestKernel(unsigned int* gRet, unsigned int* gOpA, unsigned int* gOpB)
{
	unsigned int cnt_i;
	__syncthreads();
	for(cnt_i = 0; cnt_i < NUMLOOP; cnt_i++)
	{
		setValue1(gRet, gOpA, gOpB);
	}
	__syncthreads();
}

__global__ void 
CoalscedMemTestKernel(unsigned int* gRet, unsigned int* gOpA, unsigned int* gOpB)
{
	unsigned int cnt_i;
	__syncthreads();
	for(cnt_i = 0; cnt_i < NUMLOOP; cnt_i++)
	{
		setValue2(gRet, gOpA, gOpB);
	}
	__syncthreads();
}

